package com.spicysoft.sample.dribble;

import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.view.MotionEvent;
import android.view.SurfaceView;

/** Q[I[o[ */
final class OverScene implements Scene
{
  /** ͂邽߁AʂJĂ莞(2b)́A͑𖳌Ƃ */
  private final static long WAIT = 2000;
  /** 莞(10b)ƃ^Cgʂɖ߂ */
  private final static long AUTO = 10000;
  /** wi̕` */
  private static Paint backgroundPaint;
  /** XRA̕` */
  private Paint paintScore;
  /** ʂ\Jn */
  private long start;

  /**  */
  public void init(SurfaceView view) 
  {
    backgroundPaint = new Paint();
    backgroundPaint.setColor(Color.BLACK);

    paintScore = new Paint();
    paintScore.setTextAlign(Paint.Align.CENTER);
    paintScore.setAntiAlias(true);
    paintScore.setColor(Color.WHITE);
    paintScore.setTextSize(48);

  }

  /** ʂ̕\Jn */
  public void start(SurfaceView view)
  {
    start = System.currentTimeMillis();
    Sounds.stopBgm();
  }

  /** 
   * et[̓̓CxgIuWFNg̈ړ┻菈
   */
  public void process(SurfaceView view)
  {
    final long elapsed = System.currentTimeMillis() - start;
    final MotionEvent e = Main.event();
    if (WAIT < elapsed && e != null && e.getAction() == MotionEvent.ACTION_UP || AUTO <= elapsed) {
      Sounds.playTouch();
      Main.startScene(Main.TITLE);
    }
  }

  /** 
   * et[̕`揈
   */
  public void draw(Canvas canvas)
  {
    canvas.drawRect(0, 0, canvas.getWidth(), canvas.getHeight(), backgroundPaint);

    final int centerX = canvas.getWidth() / 2;
    final int centerY = canvas.getHeight() / 2;
    canvas.drawText("L^ " + PlayLog.lastScore() + " ", centerX , centerY, paintScore);
    if (PlayLog.isLastBest()) {
      canvas.drawText("!! xXgXRA !!", centerX , centerY + paintScore.ascent() * 2, paintScore);
    }
  }
}

