package com.spicysoft.sample.dribble;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.text.DateFormat;
import java.util.Date;

import android.content.Context;
import android.util.Log;

/**
 * Ō̃XRAxXgXRAȂǂ̃vCL^Ǘ
 */
final class PlayLog
{
  /** vCL^ۊǂt@C */
  private static final String FILENAME_PLAYLOG = "playlog.dat";
  /** Q */
  private static Context context;
  
  /** Ō̃vC̃XRA */
  private static int lastScore = 0;
  /** Ō̃vCxXgXRAłǂ? */
  private static boolean isLastBest = false;

  /** xXgXRA */
  private static int bestScore = 0;
  /** xXgXRAL^ */
  private static Date bestPlayedAt;

  /**
   * vCL^Ǘ@\̏
   * @param context
   */
  public static void init(final Context context)
  {
    PlayLog.context = context;
    load();
  }

  /**
   * XRAL^B
   * XRAߋ̃xXgXRAꍇ
   * xXgXRAXVăf[^ۑB
   *
   * @param score XRA
   * @return xXgXRAȂtrueԂ
   */
  public static void logScore(final int score) {
    lastScore = score;
    isLastBest = bestScore < score;
    if (isLastBest) {
      bestScore = score;
      bestPlayedAt = new Date();
      save();
    }
  }
  
  /**
   * ŌɃvC̃XRAԂB
   * @return XRA
   */
  public static int lastScore() {
    return lastScore;
  }

  /** Ō̃vCxXgXRAH */
  public static boolean isLastBest() {
    return isLastBest;
  }

  /**
   * xXgXRAԂB
   * @return xXgXRA
   */
  public static int bestScore() {
    return bestScore;
  }

  /**
   * xXgXRAl
   */
  public static Date bestPlayedAt() {
    return bestPlayedAt;
  }

  /**
   * xXgXRAZ[u
   */
  public static void save()
  {
    try {
      final FileOutputStream fos = context.openFileOutput(FILENAME_PLAYLOG, Context.MODE_PRIVATE);
      final DataOutputStream dos = new DataOutputStream(fos);
      dos.writeInt(bestScore);
      dos.writeUTF(DateFormat.getDateInstance().format(bestPlayedAt));
      dos.flush();
      fos.close();
    } catch (IOException e) {
      Log.e("Dribble", "PlayLog.save: bestScore=" + bestScore + ",bestPlayedAt=" + bestPlayedAt, e);
    }
  }

  /**
   * xXgXRA[h
   */
  public static void load()
  {
    FileInputStream fis;
    try {
      fis = context.openFileInput(FILENAME_PLAYLOG);

    } catch(final FileNotFoundException e) {
      bestScore = 0;
      bestPlayedAt = new Date(0);
      return;
    }
    
    int tempLastScore;
    Date tempLastScorePlayed;
    try {
      final DataInputStream dis = new DataInputStream(fis);
      tempLastScore = dis.readInt();
      tempLastScorePlayed = DateFormat.getDateInstance().parse(dis.readUTF());
      fis.close();
    } catch(final Exception e) {
      Log.e("Dribble", "PlayLog.load:bestScore=" + bestScore + ",bestPlayedAt=" + bestPlayedAt, e);
      return;
    }
    bestScore = tempLastScore;
    bestPlayedAt = tempLastScorePlayed;
  }
}
