package com.spicysoft.sample.dribble;

import android.app.Activity;
import android.content.Context;
import android.os.Bundle;
import android.util.Log;
import android.view.MotionEvent;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.view.Window;

/**
 * AvP[V̋N
 */
public final class DribbleActivity extends Activity
{
  @Override public void onCreate(Bundle savedInstanceState) {
    Log.d("Dribble", "onCreate");
    super.onCreate(savedInstanceState);
    requestWindowFeature(Window.FEATURE_NO_TITLE);
    setContentView(new DribbleView(this));
  }

  @Override protected void onPause() {
    Log.d("Dribble", "onPause");
    Sounds.pauseBgm();
    super.onPause();
  }

  @Override protected void onResume() {
    Log.d("Dribble", "onResume");
    Sounds.resumeBgm();
    super.onResume();
  }

  @Override protected void onDestroy() {
    Log.d("Dribble", "onDestroy");
    super.onDestroy();
  }
}

/**
 * Q[IuWFNg̏A^b`̏Aʂ̕\̃Q[̊{sNX
 */
class DribbleView extends SurfaceView implements SurfaceHolder.Callback
{
  /** RXgN^ */
  public DribbleView(final Context context) {
    super(context);
    setFocusable(true);
    getHolder().addCallback(this);
  }

  /** ۂSurfaceViewꂽۂAPIR[obN */
  @Override public void surfaceCreated(SurfaceHolder holder) {
    Log.d("Dribble", "surfaceCreated");
    Main.createThread(this);
  }

  /** \(ʃTCY])ύXꂽۂAPIR[obN */
  @Override public void surfaceChanged(SurfaceHolder holder, int format,
      int width, int height) {
    Log.d("Dribble", "surfaceChanged");
  }

  /** SurfaceViewjꂽۂɁAAPIR[obN */
  @Override public void surfaceDestroyed(SurfaceHolder holder) {
    Log.d("Dribble", "surfaceDestroyed");
  }

  /**
   * ^b`ꂽۂAPIR[obN Q[[vŏł悤ɁA [U^b`̓tbÑANVƁA
   * ̍ۂɂǂꂮ炢{[ɉe^ANVL^
   */
  @Override public boolean onTouchEvent(final MotionEvent event) {
    Main.queue(event);
    return true;
  }

}
